using System;
using System.Data;
using System.Data.OleDb;


namespace ExercicioADOnet
{
	/// <summary>
	/// Summary description for DAL.
	/// </summary>
	public class DAL
	{
		//private const string PATH_BD = @"c:\data\Sales.mdb";
		private const string CONN_STR = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\..\contas.mdb;User ID=;Password=";

		public DAL(){}

		private OleDbConnection OpenConnection()
		{
			OleDbConnection conn = new OleDbConnection(CONN_STR);
			conn.Open();
			return conn;
		}

		public DataSet GetContas()
		{
			OleDbDataAdapter da = new OleDbDataAdapter("SELECT * FROM contas", CONN_STR);
			DataSet ds = new DataSet();
			da.Fill(ds, "contas");
			return ds;
		}

		public decimal GetSaldo(string conta){return 0;}
		public DataSet GetMovimentos(string conta){return null;}

		public DataSet GetMovimentos(int conta)
		{
			OleDbDataAdapter da = new OleDbDataAdapter("SELECT * FROM movimentos WHERE conta=" + conta.ToString(), CONN_STR);
			DataSet ds = new DataSet();
			da.Fill(ds, "movimentos");
			return ds;
		}

		public decimal AddMovimento(string conta, DateTime dt, decimal montante)
		{
			return 0;
		}

		public decimal AddMovimento(int conta, DateTime dt, decimal montante)
		{
			OleDbConnection cnx = OpenConnection();
			OleDbTransaction tx=cnx.BeginTransaction(); // inicia a transaco;
			decimal s;

			try
			{
				// Adicionar um movimento
				OleDbCommand cmd = new OleDbCommand("INSERT INTO movimentos (data, montante, conta) VALUES(?,?,?)", cnx);
				cmd.Transaction = tx;
				OleDbParameter p = cmd.Parameters.Add("data", OleDbType.Date);	p.Value = dt;
                cmd.Parameters.AddWithValue("mont", montante);
                cmd.Parameters.AddWithValue("conta", conta);
				cmd.ExecuteNonQuery(); // no retorna registos

				// Actualizar o saldo
				OleDbCommand cmd2 = new OleDbCommand("UPDATE contas SET saldo=saldo+? WHERE id=?", cnx);
				cmd2.Transaction = tx;
				cmd2.Parameters.AddWithValue("mont", montante);
                cmd2.Parameters.AddWithValue("conta", conta);
				cmd2.ExecuteNonQuery(); // no retorna registos

				// obter o saldo
				OleDbCommand cmd3 = new OleDbCommand("SELECT saldo FROM contas WHERE id=?", cnx);
				cmd3.Transaction = tx;
                cmd3.Parameters.AddWithValue("conta", conta);
				s = (decimal)cmd3.ExecuteScalar(); // retorna apenas a 1 coluna

				tx.Commit(); // faz o commit
			}
			catch(OleDbException ex)
			{
				// tratar a excepo!!!!
				if (tx != null)
					tx.Rollback();

				return -1;
			}
			finally
			{
				// fechar a conexo
				cnx.Close();
			}
			return s;
		}


        #region Typed DataSet

        public BDContas GetConta(int conta)
        {
            BDContas ds = new BDContas();
            OleDbConnection cnx = OpenConnection();
            //esta no  a maneira mais eficiente de ir buscar os dados j que vai necessitar de efectuar 2 SELECT
            //adicionalmente deveria limitar o numero de movimentos que traz
            OleDbDataAdapter da1 = new OleDbDataAdapter("SELECT * FROM contas WHERE id=" + conta.ToString(), cnx);
            OleDbDataAdapter da2 = new OleDbDataAdapter("SELECT * FROM movimentos WHERE conta=" + conta.ToString(), cnx);
            da1.Fill(ds, "contas");
            da2.Fill(ds, "movimentos");
            cnx.Close();
            return ds;
        }

        public BDContas GetConta(string numeroConta)
        {
            BDContas ds = new BDContas();
            OleDbConnection cnx = OpenConnection();
            //esta no  a maneira mais eficiente de ir buscar os dados j que vai necessitar de efectuar 2 SELECT
            //adicionalmente deveria limitar o numero de movimentos que traz
            OleDbDataAdapter da1 = new OleDbDataAdapter("SELECT * FROM contas WHERE numero='" + numeroConta + "'", cnx);
            OleDbDataAdapter da2 = new OleDbDataAdapter("SELECT * FROM movimentos WHERE conta=(SELECT id FROM contas WHERE numero = '" + numeroConta + "')", cnx);
            da1.Fill(ds, "contas");
            da2.Fill(ds, "movimentos");
            cnx.Close();
            return ds;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="dsConta"></param>
        public void UpdateConta(BDContas dsConta)
        {
            //
            //apenas vai considerar os novos movimentos e a actualizao do saldo  calculada
            //

            //obter linhas adicionadas
            DataSet ds = dsConta.GetChanges(DataRowState.Added);
            if (ds == null)
                return;

            //calcular diferencial do saldo
            decimal s = 0;
            foreach (BDContas.movimentosRow r in ds.Tables["movimentos"].Rows)
                s += r.montante;

            //abrir conexo e iniciar transaco
            OleDbConnection cnx = OpenConnection();
            OleDbTransaction tx = cnx.BeginTransaction();

            //construir DataAdpter e definir comandos SQL auxiliares vi OleDbCommandBuilder
            OleDbDataAdapter da = new OleDbDataAdapter("SELECT * FROM movimentos", cnx);
            da.SelectCommand.Transaction = tx;
            OleDbCommandBuilder cb = new OleDbCommandBuilder(da);

            // actualziar tabela de movimentos
            da.Update(ds, "movimentos");

            //actualizar saldo da conta
            OleDbCommand cmd2 = new OleDbCommand("UPDATE contas SET saldo=saldo+? WHERE id=?", cnx);
            cmd2.Transaction = tx;
            cmd2.Parameters.AddWithValue("mont", s);
            cmd2.Parameters.AddWithValue("conta", dsConta.contas[0].ID);
            cmd2.ExecuteNonQuery();

            //terminar transaco e fechar conexo
            tx.Commit();
            cnx.Close();
        }
        #endregion

	}
}
